## This file goes through all the topics discussed in Recitation 2. 
## If you only want to practice one section, we recommend that you comment out
## the sections you are not working on, so that the outputs are not confusing. 

#############################################################################
#  Functions
#############################################################################


## The difference between print and return
## Functions automatically return None if not specified
def function_that_prints():
    print ("Look! I am a function that prints! \n")
    
print("Invoking function that prints: ", function_that_prints())

def function_that_returns():
    return ("Look! I am a function that returns!")
 
print("\nInvoking function that returns: ", function_that_returns()) #Where did the none in between the two come from?


## Nothing is executed after the return statement
def mult_by_five(number):
    print ("Before return: ", number*5)
    return number*5
    print ("After return: This is the best recitation!")
    
multiple_of_five = mult_by_five(3)
print (multiple_of_five)


## The "pass" statement
## This prevents syntax error from being thrown.
## you'll see this in many of the psets. 
def even_or_odd(number):
    if number == 2:
        pass

print(even_or_odd(2))


## Be careful about argument Types
def mult_by_five(number):
    return("number * 5 =", number*5)
    
print(mult_by_five(2)) # what do you think happens? 
print(mult_by_five("2")) # what do you think happens now?

## Example: Computing a Restaurant Bill Using Functions
## function parameters can have default values, this means that the parameter is now optional  
def add_tax(bill, tax_rate = 0.08): # here tax_rate is a default parameter
    """Adds tax (8% by default) to a restaurant bill."""
    bill *= 1.0 + tax_rate
    print ("With tax:", bill)
    return bill

def add_tip(bill, tip_percent = 0.15): # tip_percent is a default parameter
    """Adds tip (15% by default) to a restaurant bill."""
    bill *= 1 + tip_percent
    print ("With tip:", bill)
    return bill

meal_cost = float(input("Enter meal cost: ")) # gets input from the user
print ("Base cost of meal: ", meal_cost)      
print ("Computing tax...")
meal_with_tax = add_tax(meal_cost)            # calls/invokes the add_tax functions, saves result to variable
print ("Computing tip...")
meal_with_tip = add_tip(meal_with_tax, tip_percent)        # calls/invokes the add_tip functions, saves result to variable


#############################################################################
#  Scope
#############################################################################

two = 2 # global scope
def add_2(number):
    number += 2  # this is the same as number = number + 2 
    #two += 2 # Can we do this, Why or why not? 
    #two = 6 # Can we do this, Why or why not? 
    print("Inside add_2, number is", number)
    #print("Inside add_2, two is", two)
    return number, two, "Mesi"

print(add_2(10)) 
four = add_2(two) # This is okay! It doesn’t have to be called number
print(four)

## Now uncomment the line 'two = 6' above
print("two is", two) # Which 'two' will this print?
print("four is", four)
print("number is", number) 


#############################################################################
#  Recursion
#############################################################################

# NOTE: The prints slow the following code down significantly, so for anything 
# greater than x = 20, we recommend commenting out the prints otherwise your environment 
# might freeze for a bit

def fibonacci(x): 
    #print ('Computing: ', x)
    if x <= 1: 
        return 1
    return fibonacci(x-1) + fibonacci(x-2)
print(fibonacci(10))

def factorial(x):
    #print('Computing: ', x)
    if x == 0:
        return 1
    return x * factorial(x - 1)

#factorial(7)
print(factorial(7))


#############################################################################
#  Loops
#############################################################################

# for loop
## Note: all For loops can be written as While loops, but not the other way around

## Prints out each letter in word in a newline
word = "goldfish"

for letter in word:
    print(letter)
    # Inside this block, letter will refer to each character in the word in turn

# while loop 
## Prints out each letter in word in a newline
letter_number = 0
while letter_number < len(word):
    letter = word[letter_number]
    print(letter)
    letter_number += 1

## Repeatedly asks users to guess a number until 13 is guessed
player_has_lost = False

while not player_has_lost:
    player_choice = input("Guess A Number: ")
    chosen_number = int(player_choice)

    # 13 is Unlucky
    if chosen_number == 13:
        player_has_lost = True

print("Too Bad. You guessed unlucky 13 :(")
# Not so unlucky if you wanted to leave the game :)

# nested loops
# note that range is inclusive on start and exclusive on end
for val_1 in range(1,3):
    for val_2 in range(10,12):
        print('val_1 =',val_1)
        print('val_2 =',val_2)
        print('-------')

#############################################################################
#  Range
#############################################################################

## 1 Argument: From 0 (inclusive) to x (exclusive)
for x in range(10):
    print(x)

## 2 Arguments: From x (inclusive) to y (exclusive)
for x in range(10,20):
    print(x)

## 3 Arguments: From x (inclusive) to y (exclusive), with step size z
for x in range(10,20,2):
    print(x)


#############################################################################
#  Break and Continue
#############################################################################
print("What is the difference between break and continue?")

while True:
    user_input = input("Enter an input: ")
    
    if user_input == "break":
        print("Break out of loop")
        break
    elif user_input == "continue":
        print("Continue to next iteration")
        continue    
    print("Neither break nor continue entered")
    print("Neither break nor continue entered")
    print("Neither break nor continue entered")
    print("Neither break nor continue entered")


#############################################################################
#  Bisection Search
#############################################################################

# Approximating a square root: Exhaustive search
## Possible mistakes include forgetting the 'abs' (guessing too low means only one time through the loop)
x = 16
g = 7
epsilon = 0.001
guess = 0
print("What is the square root of", x)
while abs(g*g - x) >= epsilon:
    guess+=1
    print("Guess",guess,":", g)
    g = 0.5*(g + x/g)

print("sqrt(" + str(x) + ") is approximately:", g)

## Approximating a Square Root: Bisection Search
x = 64
# x = 0.81
# x = 0.25

epsilon = 0.01
num_guesses = 0
low = 0

if x > 1:
    high = x
else: # square of a number < 1 
    high = 1.0
guess = (high + low)/2.0
while abs(guess**2 - x) >= epsilon:
    if guess**2 < x:
        low = guess
    else:
        high = guess
    guess = (high + low)/2.0
    num_guesses += 1
print('Number of Guesses =', num_guesses)
print("sqrt(" + str(x) + ") is approximately:", guess)

